#ifndef CRC32_h
#define CRC32_h
#include <stddef.h>
#include <stdint.h>

// it needs to be declared but not implemented, otherwise, multiple definitions
// will occur
extern const uint32_t CRC32_INIT;
extern const uint32_t CRC32_TABLE[256];

typedef uint32_t ChecksumCrc32;

typedef struct Crc32 {
  ChecksumCrc32 buf;
} Crc32;

Crc32 crc32_new();
void crc32_process(const char *data, size_t len, Crc32 *crc32);

ChecksumCrc32 crc32_checksum(const void *data, uint32_t len);
#endif
